Meet our new project:Cladd — A React UI kit for building actual apps

Photo Browser Vue Component

Photo Browser is an photo browser component to display collection of photos / images. Photos can be zoomed and panned (optional).

Photo Browser Vue component represents Framework7's Photo Browser component.

Photo Browser Vue component doesn't render any output. It can be used to create JS Photo Browser instance and control it inside of your Vue component.

Framework7 v9: Photo Browser now automatically uses your app's theme (light/dark mode). The theme and captions-theme props have been removed. Back and close link text now defaults to icon only.

Photo Browser Component

There are following components included:

Photo Browser Properties

You can pass all parameters in single params property or use separate props for each parameter to specify them via component properties:

PropTypeDefaultDescription
<f7-photo-browser> properties
initbooleantrueInitializes Photo Browser
paramsObjectObject with Photo Browser parameters
photosarray[]Array with URLs of photos or array of objects with "url" (or "html") and "caption" properties.
thumbsarray[]Array with URLs of thumbs images. Will not render thumbs if not specified, or empty array
urlstringphotos/Photo browser modal URL that will be set as a current route
routable-modalsbooleanfalseWill add opened photo browser to router history which gives ability to close photo browser by going back in router history and set current route to the photo browser modal
swiperobjectObject with Swiper parameters. By default equals to:
swiper: {
  initialSlide: 0,
  spaceBetween: 20,
  speed: 300,
  loop: false,
  preloadImages: true,
  keyboard: {
    enabled: true,
  },
  navigation: {
    nextEl: '.photo-browser-next',
    prevEl: '.photo-browser-prev',
  },
  zoom: {
    enabled: true,
    maxRatio: 3,
    minRatio: 1,
  },
  lazy: {
    enabled: true,
  },
},
virtual-slidesbooleantrueWhen enabled then Swiper will use Virtual Slides
close-by-backdrop-clickbooleantrueWhen enabled, Photo Browser popup will be closed on backdrop click
expositionbooleantrueEnable disable exposition mode when clicking on Photo Browser.
exposition-hide-captionsbooleanfalseSet to true if you also want to hide captions in exposition mode
swipe-to-closebooleantrueYou can close Photo Browser with swipe up/down when this parameter is enabled
typestringstandaloneDefine how Photo Browser should be opened. Could be standalone (will be opened as an overlay with custom transition effect), popup (will be opened as popup), page (will be injected to View and loaded as a new page).
navbarbooleantrueSet to false to remove Photo Browser's Navbar
toolbarbooleantrueSet to false to remove Photo Browser's Toolbar
page-back-link-textstringText on back link in Photo Browser's navbar. By default uses icon only (no text)
popup-close-link-textstringText on close link in Photo Browser's navbar when opened in Popup or as Standalone. By default uses icon only (no text)
navbar-show-countbooleanundefinedDefines should it display "3 of 5" text in navbar title or not. If not specified (undefined) then it will show this text if there is more than 1 item
navbar-of-textstringofText of "of" in photos counter: "3 of 5"
icons-colorstringOne of the default colors

Photo Browser Events

EventDescription
<f7-photo-browser> events
photobrowser:openEvent will be triggered on Photo Browser open.
photobrowser:openedEvent will be triggered after Photo Browser completes its opening animation
photobrowser:closeEvent will be triggered on Photo Browser close.
photobrowser:closedEvent will be triggered after Photo Browser completes its closing animation
photobrowser:swipetocloseThis event will be triggered when user close Photo Browser with swipe up/down.

Photo Browser Methods

The following Photo Browser components methods are available (e.g. by accesing it via $refs):

<f7-photo-browser> methods
.open(index)Open Photo Browser on photo with index number equal to "index" parameter. If "index" parameter is not specified, it will be opened on last closed photo.
.close()Close Photo Browser
.expositionToggle()Toggle exposition mode
.expositionEnable()Enable exposition mode
.expositionDisable()Disable exposition mode

Examples

photo-browser.vue
<template>
  <f7-page>
    <f7-navbar title="Photo Browser" back-link></f7-navbar>
    <f7-block strong inset>
      <p>
        Photo Browser is a standalone and highly configurable component that allows to open window
        with photo viewer and navigation elements with the following features:
      </p>
      <ul>
        <li>Swiper between photos</li>
        <li>Multi-gestures support for zooming</li>
        <li>Toggle zoom by double tap on photo</li>
        <li>Single click on photo to toggle Exposition mode</li>
      </ul>
    </f7-block>
    <f7-block strong inset>
      <p>
        Photo Browser could be opened in a three ways - as a Standalone component (Popup
        modification), in Popup, and as separate Page:
      </p>
      <div class="grid grid-cols-3 grid-gap">
        <div>
          <f7-photo-browser ref="standalone" :photos="photos" :thumbs="thumbs" />
          <f7-button round fill @click="$refs.standalone.open()">Standalone</f7-button>
        </div>
        <div>
          <f7-photo-browser ref="popup" :photos="photos" :thumbs="thumbs" type="popup" />
          <f7-button round fill @click="$refs.popup.open()">Popup</f7-button>
        </div>
        <div>
          <f7-photo-browser
            ref="page"
            :photos="photos"
            :thumbs="thumbs"
            type="page"
            page-back-link-text="Back"
          />
          <f7-button round fill @click="$refs.page.open()">Page</f7-button>
        </div>
      </div>
    </f7-block>
  </f7-page>
</template>
<script>
import { f7Navbar, f7Page, f7PhotoBrowser, f7Block, f7Button } from 'framework7-vue';

export default {
  components: { f7Navbar, f7Page, f7PhotoBrowser, f7Block, f7Button },
  data() {
    return {
      photos: [
        { url: 'img/beach.jpg', caption: 'Amazing beach in Goa, India' },
        'http://placekitten.com/1024/1024',
        'img/lock.jpg',
        { url: 'img/monkey.jpg', caption: 'I met this monkey in Chinese mountains' },
        { url: 'img/mountains.jpg', caption: 'Beautiful mountains in Zhangjiajie, China' },
      ],
      thumbs: [
        'img/beach.jpg',
        'http://placekitten.com/1024/1024',
        'img/lock.jpg',
        'img/monkey.jpg',
        'img/mountains.jpg',
      ],
    };
  },
};
</script>

Meet our new project:Cladd — A React UI kit for building actual apps

Photo Browser Svelte Component

Photo Browser is an photo browser component to display collection of photos / images. Photos can be zoomed and panned (optional).

Photo Browser Svelte component represents Framework7's Photo Browser component.

Photo Browser Svelte component doesn't render any output. It can be used to create JS Photo Browser instance and control it inside of your Svelte component.

Framework7 v9: Photo Browser now automatically uses your app's theme (light/dark mode). The theme and captionsTheme props have been removed. Back and close link text now defaults to icon only.

Photo Browser Component

There are following components included:

Photo Browser Properties

You can pass all parameters in single params property or use separate props for each parameter to specify them via component properties:

PropTypeDefaultDescription
<PhotoBrowser> properties
initbooleantrueInitializes Photo Browser
paramsObjectObject with Photo Browser parameters
photosarray[]Array with URLs of photos or array of objects with "url" (or "html") and "caption" properties.
thumbsarray[]Array with URLs of thumbs images. Will not render thumbs if not specified, or empty array
urlstringphotos/Photo browser modal URL that will be set as a current route
routableModalsbooleanfalseWill add opened photo browser to router history which gives ability to close photo browser by going back in router history and set current route to the photo browser modal
swiperobjectObject with Swiper parameters. By default equals to:
swiper: {
  initialSlide: 0,
  spaceBetween: 20,
  speed: 300,
  loop: false,
  preloadImages: true,
  keyboard: {
    enabled: true,
  },
  navigation: {
    nextEl: '.photo-browser-next',
    prevEl: '.photo-browser-prev',
  },
  zoom: {
    enabled: true,
    maxRatio: 3,
    minRatio: 1,
  },
  lazy: {
    enabled: true,
  },
},
virtualSlidesbooleantrueWhen enabled then Swiper will use Virtual Slides
closeByBackdropClickbooleantrueWhen enabled, Photo Browser popup will be closed on backdrop click
expositionbooleantrueEnable disable exposition mode when clicking on Photo Browser.
expositionHideCaptionsbooleanfalseSet to true if you also want to hide captions in exposition mode
swipeToClosebooleantrueYou can close Photo Browser with swipe up/down when this parameter is enabled
typestringstandaloneDefine how Photo Browser should be opened. Could be standalone (will be opened as an overlay with custom transition effect), popup (will be opened as popup), page (will be injected to View and loaded as a new page).
navbarbooleantrueSet to false to remove Photo Browser's Navbar
toolbarbooleantrueSet to false to remove Photo Browser's Toolbar
pageBackLinkTextstringText on back link in Photo Browser's navbar. By default uses icon only (no text)
popupCloseLinkTextstringText on close link in Photo Browser's navbar when opened in Popup or as Standalone. By default uses icon only (no text)
navbarShowCountbooleanundefinedDefines should it display "3 of 5" text in navbar title or not. If not specified (undefined) then it will show this text if there is more than 1 item
navbarOfTextstringofText of "of" in photos counter: "3 of 5"
iconsColorstringOne of the default colors

Photo Browser Events

EventDescription
<PhotoBrowser> events
photoBrowserOpenEvent will be triggered on Photo Browser open.
photoBrowserOpenedEvent will be triggered after Photo Browser completes its opening animation
photoBrowserCloseEvent will be triggered on Photo Browser close.
photoBrowserClosedEvent will be triggered after Photo Browser completes its closing animation
photoBrowserSwipeToCloseThis event will be triggered when user close Photo Browser with swipe up/down.

Photo Browser Methods

The following Photo Browser components methods are available (e.g. by accesing it via bind:this):

<PhotoBrowser> methods
.open(index)Open Photo Browser on photo with index number equal to "index" parameter. If "index" parameter is not specified, it will be opened on last closed photo.
.close()Close Photo Browser
.expositionToggle()Toggle exposition mode
.expositionEnable()Enable exposition mode
.expositionDisable()Disable exposition mode

Access To Photo Browser Instance

You can access Photo Browser initialized instance by calling .instance() component's method. For example:

<PhotoBrowser bind:this={component}>...</PhotoBrowser>

<script>
  let component;

  // to get instance in some method
  component.instance()
</script>

Examples

photo-browser.svelte
<script>
  import { Navbar, Page, PhotoBrowser, Block, Button } from 'framework7-svelte';

  let standalone;
  let popup;
  let page;

  let standaloneDark;
  let popupDark;
  let pageDark;

  const photos = [
    {
      url: 'img/beach.jpg',
      caption: 'Amazing beach in Goa, India',
    },
    'http://placekitten.com/1024/1024',
    'img/lock.jpg',
    {
      url: 'img/monkey.jpg',
      caption: 'I met this monkey in Chinese mountains',
    },
    {
      url: 'img/mountains.jpg',
      caption: 'Beautiful mountains in Zhangjiajie, China',
    },
  ];

  const thumbs = [
    'img/beach.jpg',
    'http://placekitten.com/1024/1024',
    'img/lock.jpg',
    'img/monkey.jpg',
    'img/mountains.jpg',
  ];
</script>

<Page>
  <Navbar title="Photo Browser" backLink />
  <Block strong inset>
    <p>
      Photo Browser is a standalone and highly configurable component that allows to open window
      with photo viewer and navigation elements with the following features:
    </p>
    <ul>
      <li>Swiper between photos</li>
      <li>Multi-gestures support for zooming</li>
      <li>Toggle zoom by double tap on photo</li>
      <li>Single click on photo to toggle Exposition mode</li>
    </ul>
  </Block>
  <Block strong inset>
    <p>
      Photo Browser could be opened in a three ways - as a Standalone component (Popup
      modification), in Popup, and as separate Page:
    </p>
    <div class="grid grid-cols-3 grid-gap">
      <div>
        <PhotoBrowser {photos} {thumbs} bind:this={standalone} />
        <Button round fill onClick={() => standalone.open()}>Standalone</Button>
      </div>
      <div>
        <PhotoBrowser {photos} {thumbs} type="popup" bind:this={popup} />
        <Button round fill onClick={() => popup.open()}>Popup</Button>
      </div>
      <div>
        <PhotoBrowser {photos} {thumbs} type="page" pageBackLinkText="Back" bind:this={page} />
        <Button round fill onClick={() => page.open()}>Page</Button>
      </div>
    </div>
  </Block>
</Page>

Meet our new project:Cladd — A React UI kit for building actual apps

Photo Browser React Component

Photo Browser is an photo browser component to display collection of photos / images. Photos can be zoomed and panned (optional).

Photo Browser React component represents Framework7's Photo Browser component.

Photo Browser React component doesn't render any output. It can be used to create JS Photo Browser instance and control it inside of your React component.

Framework7 v9: Photo Browser now automatically uses your app's theme (light/dark mode). The theme and captionsTheme props have been removed. Back and close link text now defaults to icon only.

Photo Browser Component

There are following components included:

Photo Browser Properties

You can pass all parameters in single params property or use separate props for each parameter to specify them via component properties:

PropTypeDefaultDescription
<PhotoBrowser> properties
initbooleantrueInitializes Photo Browser
paramsObjectObject with Photo Browser parameters
photosarray[]Array with URLs of photos or array of objects with "url" (or "html") and "caption" properties.
thumbsarray[]Array with URLs of thumbs images. Will not render thumbs if not specified, or empty array
urlstringphotos/Photo browser modal URL that will be set as a current route
routableModalsbooleanfalseWill add opened photo browser to router history which gives ability to close photo browser by going back in router history and set current route to the photo browser modal
swiperobjectObject with Swiper parameters. By default equals to:
swiper: {
  initialSlide: 0,
  spaceBetween: 20,
  speed: 300,
  loop: false,
  preloadImages: true,
  keyboard: {
    enabled: true,
  },
  navigation: {
    nextEl: '.photo-browser-next',
    prevEl: '.photo-browser-prev',
  },
  zoom: {
    enabled: true,
    maxRatio: 3,
    minRatio: 1,
  },
  lazy: {
    enabled: true,
  },
},
virtualSlidesbooleantrueWhen enabled then Swiper will use Virtual Slides
closeByBackdropClickbooleantrueWhen enabled, Photo Browser popup will be closed on backdrop click
expositionbooleantrueEnable disable exposition mode when clicking on Photo Browser.
expositionHideCaptionsbooleanfalseSet to true if you also want to hide captions in exposition mode
swipeToClosebooleantrueYou can close Photo Browser with swipe up/down when this parameter is enabled
typestringstandaloneDefine how Photo Browser should be opened. Could be standalone (will be opened as an overlay with custom transition effect), popup (will be opened as popup), page (will be injected to View and loaded as a new page).
navbarbooleantrueSet to false to remove Photo Browser's Navbar
toolbarbooleantrueSet to false to remove Photo Browser's Toolbar
pageBackLinkTextstringText on back link in Photo Browser's navbar. By default uses icon only (no text)
popupCloseLinkTextstringText on close link in Photo Browser's navbar when opened in Popup or as Standalone. By default uses icon only (no text)
navbarShowCountbooleanundefinedDefines should it display "3 of 5" text in navbar title or not. If not specified (undefined) then it will show this text if there is more than 1 item
navbarOfTextstringofText of "of" in photos counter: "3 of 5"
iconsColorstringOne of the default colors

Photo Browser Events

EventDescription
<PhotoBrowser> events
photoBrowserOpenEvent will be triggered on Photo Browser open.
photoBrowserOpenedEvent will be triggered after Photo Browser completes its opening animation
photoBrowserCloseEvent will be triggered on Photo Browser close.
photoBrowserClosedEvent will be triggered after Photo Browser completes its closing animation
photoBrowserSwipeToCloseThis event will be triggered when user close Photo Browser with swipe up/down.

Photo Browser Methods

The following Photo Browser components methods are available (e.g. by accesing it via ref):

<PhotoBrowser> methods
.open(index)Open Photo Browser on photo with index number equal to "index" parameter. If "index" parameter is not specified, it will be opened on last closed photo.
.close()Close Photo Browser
.expositionToggle()Toggle exposition mode
.expositionEnable()Enable exposition mode
.expositionDisable()Disable exposition mode

Examples

photo-browser.jsx
import React, { useRef } from 'react';
import { Navbar, Page, PhotoBrowser, Block, Button } from 'framework7-react';

export default () => {
  const standalone = useRef(null);
  const popup = useRef(null);
  const page = useRef(null);

  const photos = [
    { url: 'img/beach.jpg', caption: 'Amazing beach in Goa, India' },
    'http://placekitten.com/1024/1024',
    'img/lock.jpg',
    { url: 'img/monkey.jpg', caption: 'I met this monkey in Chinese mountains' },
    { url: 'img/mountains.jpg', caption: 'Beautiful mountains in Zhangjiajie, China' },
  ];
  const thumbs = [
    'img/beach.jpg',
    'http://placekitten.com/1024/1024',
    'img/lock.jpg',
    'img/monkey.jpg',
    'img/mountains.jpg',
  ];
  return (
    <Page>
      <Navbar title="Photo Browser" backLink></Navbar>
      <Block strong inset>
        <p>
          Photo Browser is a standalone and highly configurable component that allows to open window
          with photo viewer and navigation elements with the following features:
        </p>
        <ul>
          <li>Swiper between photos</li>
          <li>Multi-gestures support for zooming</li>
          <li>Toggle zoom by double tap on photo</li>
          <li>Single click on photo to toggle Exposition mode</li>
        </ul>
      </Block>
      <Block strong inset>
        <p>
          Photo Browser could be opened in a three ways - as a Standalone component (Popup
          modification), in Popup, and as separate Page:
        </p>
        <div className="grid grid-cols-3 grid-gap">
          <div>
            <PhotoBrowser photos={photos} thumbs={thumbs} ref={standalone} />
            <Button round fill onClick={() => standalone.current.open()}>
              Standalone
            </Button>
          </div>
          <div>
            <PhotoBrowser photos={photos} thumbs={thumbs} type="popup" ref={popup} />
            <Button round fill onClick={() => popup.current.open()}>
              Popup
            </Button>
          </div>
          <div>
            <PhotoBrowser photos={photos} thumbs={thumbs} type="page" ref={page} />
            <Button round fill onClick={() => page.current.open()}>
              Page
            </Button>
          </div>
        </div>
      </Block>
    </Page>
  );
};